#include <bits/stdc++.h>
using namespace std;

int main(){
	int n,q;
	cin>>n>>q;
	string s;
	cin>>s;
	int levo,r;
	for(int i=0;i<q;i++){
		cin>>levo>>r;
		int resenje=0;
		bool postoji=false;
		bool prvi=false;
		int br_6=0,br_7=0;
		for (int l=levo-1;l<r;l++){
			if(s[l]=='7' && !prvi){
				s[i]='6';
			}
			else if(s[l]=='?' && prvi){
				s[i]='7';
			}
			if(s[i]=='6')br_6++;
			else br_7++;
		}
		int pomocna_poz=0;
		for (int l=levo-1;l<r;l++){
			if(s[l]=='6' && l!=r-1){
				postoji=true;
				resenje+=br_7;
				pomocna_poz=l;
				br_7-=l-pomocna_poz;
			}
		}
		cout<<resenje<<endl;
	}
}